<?php

function get_rosa($t_id = '') {

	$args = array (
		't_id' => $t_id
	);
	$out .= make_columns('show_rosa', 'rose', $args);

	return $out;

}

function show_rosa($args) {

	define("CREDITI", 430);

	$teams = get_teams();
	$players = get_players();

	$t_id = $args['t_id'];

	$out = "<h3>" . $teams[$t_id]['name'] . "</h3><br>";

	$out .= "<div class='shirt'><img src='" . base_path() . $teams[$t_id]['shirt'] . "'></div>";

	$out .= "\n<table class='rosa'>" .
	"\n<tr>" .
	"\n<th>Ruolo</th>" .
	"\n<th>Nome</th>" .
	"\n<th>Squadra</th>" .
	"\n<th>Costo</th>" .
	"\n</tr>";
	
	$header = array("Ruolo", "Nome", "Squadra", "Costo");

	$rose = array(); $spesa = 0;
	$sql = "SELECT * FROM {fanta_rose} WHERE t_id = $t_id ";
	$result = db_query($sql) or die($sql . mysql_error());
	while ($row = db_fetch_array($result)) {
		$rose[] = $row;
	}

	foreach($rose as $rosa){
		$roles[] = $players[$rosa['pl_id']]->role;
		$names[] = $players[$rosa['pl_id']]->name;
	}

	array_multisort($roles, SORT_ASC, $names, SORT_ASC, $rose);

	foreach($rose as $rosa){

		if($rosa["in_squadra"] == 1){

			$out .= "\n<tr class='role_" . $players[$rosa['pl_id']]->role . "'>";
			$out .= "\n<td>" . convert_ruolo($players[$rosa['pl_id']]->role) . "</td>";
			$out .= "\n<td class='name'>" . $players[$rosa['pl_id']]->name . "</td>";
			$out .= "\n<td>" . ucwords(convert_teams($players[$rosa['pl_id']]->team)) . "</td>";
			$out .= "\n<td>" . $rosa['costo'] . "</td>";

			$out .= "\n<td><a rel='lightframe[".$t_id."|width:770px;]' href='".base_path()."scheda/giocatore/".$rosa['pl_id']."' title='Dettagli giocatore'>" .
			"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>" .
			"</a></td>";

			$out .= "\n</tr>";
			
			$rows[] = array("data" => array(
											convert_ruolo($players[$rosa['pl_id']]->role),
											array("data" => $players[$rosa['pl_id']]->name, "class" => "name"),
											ucwords(convert_teams($players[$rosa['pl_id']]->team)),
											$rosa['costo'],
											"<a rel='lightframe[".$t_id."|width:770px;]' href='".base_path()."scheda/giocatore/".$rosa['pl_id']."' title='Dettagli giocatore'>" .
			"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>" .
			"</a>"
											), 
							"class" => "role_".$players[$rosa['pl_id']]->role
						);
		}

		$recupero = ($rosa["in_squadra"] == -1) ? ceil($rosa["costo"] / 2) : 0;
		$spesa += $rosa["costo"] - $recupero;
	}

	$out .= "\n</table>";
	
	$out = "<h3>" . $teams[$t_id]['name'] . "</h3><br>";

	$out .= "<div class='shirt'><img src='" . base_path() . $teams[$t_id]['shirt'] . "'></div>";
	
	
	$out .= theme_table($header, $rows, array("class" => "rosa"));

	$rows_budget[] = array("Crediti", CREDITI);
	$rows_budget[] = array("Spesi", $spesa);
	$rows_budget[] = array("Rimasti", "<strong>".(CREDITI - $spesa)."</strong>");

	$out .= theme_table(array(), $rows_budget);

	return $out;
}

function get_formazione($args = array()) {

	$l_name = $args["l_name"];
	$t_id = $args["t_id"];
	$round = $args["round"];

	$l_id = get_league_id($l_name);
	$args["l_id"] = $l_id;
	$round = (!empty ($round)) ? $round : get_last_round_formazione($l_id);

	$out .= make_columns('show_formazione', 'formazioni/' . $l_name . '/' . $round, $args, 'filter_teams_formazioni', $args);

	return $out;

}

function show_formazione($args = array ()) {

	$teams = get_teams();
	$players = get_players();
	$leagues = get_leagues();

	$t_id = $args['t_id'];
	$l_name = $leagues[$args['l_id']]->name;
	$l_id = get_league_id($l_name);
	$round = (!empty ($args['round'])) ? $args['round'] : get_last_round_formazione($l_id);

	$out = "";

	#form per la giornata e il campionato
	$out .= change_round_and_league();

	#squadra trovata
	if (array_key_exists($t_id, $teams)) {

		$out .= "<h3 class='team_name'>" . $teams[$t_id]['name'] . "</h3><br>";

		$out .= "<div class='shirt'><img src='" . base_path() . $teams[$t_id]['shirt'] . "'></div>";

		$formazione = array ();
		$titolari = array ();
		$riserve = array ();
		$sql = "SELECT * FROM {fanta_formazioni} " .
						"WHERE t_id = '%d'
						 AND l_id = '%d' " .
						"AND round = '%d'";
		$result = db_query($sql, $t_id, $l_id, $round);
		if (db_affected_rows($result) > 0) {
			while ($row = db_fetch_object($result)) {
				$pl_id = $row->pl_id;
				$formazione[$pl_id] = $row;
				$posizioni[$row->posizione][$pl_id] = $row;
				if ($row->posizione == 1)
					$titolari[$pl_id] = $row;
				elseif (in_array($row->posizione, array (
					2,
					3
				))) $riserve[$pl_id] = $row;
			}

			ksort($posizioni);

			#ordino i titolari (ruolo, nome)
			$ruoli = array ();
			$nomi = array ();

			foreach ($titolari as $p_id => $player) {
				$ruoli[$player->pl_id] = $players[$p_id]->role;
				$nomi[$players[$p_id]->name] = $player->pl_id;
			}

			$modulo = array();
			foreach ($titolari as $p_id => $player) {
				$modulo[$players[$player->pl_id]->role]++;
				$new_id = $players[$player->pl_id]->role + $nomi[$players[$p_id]->name];
				$new_titolari[$new_id] = $player;
			}

			ksort($new_titolari);

			$titolari = $new_titolari;

			#ordino le riserve (ruolo, posizione, nome)
			$ruoli = array ();
			$nomi = array ();

			foreach ($riserve as $p_id => $player) {
				$ruoli[$player->pl_id] = $players[$p_id]->role;
				$nomi[$players[$p_id]->name] = $player->pl_id;
			}

			foreach ($riserve as $p_id => $player) {

				$new_id = $players[$player->pl_id]->role * 10000 + $player->posizione * 1000 + $nomi[$players[$p_id]->name];
				$new_riserve[$new_id] = $player;
			}

			ksort($new_riserve);
			ksort($modulo);

			$riserve = $new_riserve;

			unset($modulo[0]);
			$out .= "<p><strong>".implode(" - ", $modulo)."</strong></p>";

			#creo la tabella
			$out .= "\n<table class='rosa'>" .
			"\n<tr>" .
			"\n<th>Ruolo</th>" .
			"\n<th>Nome</th>" .
			"\n<th>Squadra</th>" .
			"\n<th></th>" .
			"\n</tr>";

			#titolari
			$out .= "<tr><td colspan=4><h4>Titolari</h4></td></tr>";
			$out .= show_posizione($titolari, $players);

			#riserve
			$out .= "<tr><td colspan=4><h4>Riserve</h4></td></tr>";
			$out .= show_posizione($riserve, $players);

			$out .= "\n</table>";

		} else
			$out .= "<p>Formazione non trovata</p>";

	} else
		$out .= "<h3>Squadra inesistente</h3><br>";

	return $out;
}

function make_columns($function, $link, $array_args = array (), $filter = '') {

	drupal_add_css('sites/all/modules/fantacalcio/style.css', 'themes', 'all', FALSE);
	drupal_add_js('sites/all/modules/fantacalcio/js/formazioni.js');

	$teams = get_teams();
	$leagues = get_leagues();
	$groups = get_groups();

	if ($filter != '') $teams = $filter ($teams, $array_args);

	#squadre
	$out = "\n<div id='teams'>";

	if (isset ($array_args['l_id'])) {
		$league_name = $leagues[$array_args['l_id']]->name;
		$out .= "<h3>" . $league_name . "</h3>";
	}
	if (isset ($array_args['round'])) {
		$round_formazioni = get_round_formazioni($array_args['l_id']);
		#$out .= fantacalcio_form_choose_round($form_state, $l_id);
		$out .= "\n<h4>" .
		"\n<form action='' name='form_$league_name' id='form'>Giornata " .
		"\n<select name='round_$league_name' id='round_$league_name' onchange='change_round(\"$league_name\", \"" . base_path() . "\")'>";
		foreach ($round_formazioni as $round => $round_label) {
			if ($round == $array_args['round'])
				$selected = "selected";
			else
				$selected = '';

			$out .= "<option value='$round' $selected>" . $round_label . "</option>";
		}
		$out .= "\n</select>" .
		"\n</form>" .
		"\n</h4>";

	}

	$out .= "<div style='margin-top: 20px;'>";

	if(isset($array_args['l_id'])) $l_id_groups = $array_args['l_id'];
	else $l_id_groups = 1;
	$groups_teams = get_groups_teams($l_id_groups);

	$js = "function show(div){
				var id = document.getElementById(div);
				if(id.style.display == 'none')
					id.style.display = 'block';
				else id.style.display = 'none';
			}";
	drupal_add_js($js, 'inline');

	foreach($groups_teams as $g_id => $group_teams){

		$out .= "<h3><a style='cursor:pointer;' onclick='show(\"group_".$g_id."\");'>".$groups[$g_id]['name']."</a></h3>";

		$teams_names = array();
		foreach ($group_teams as $t_id => $team) {
			$teams_names[$t_id] = $teams[$t_id]['name'];
		}

		array_multisort($teams_names, $group_teams);

		$out_teams = ""; $display = "none";
		foreach ($group_teams as $t_id => $team) {
			$class = ($team == $array_args['t_id'] && $array_args["l_name"] == $array_args["selected_league"]) ? "selected" : "";
			$out_teams .= "\n<li class='$class'><a href='" . base_path() . $link . "/" . $team . "'>" . $teams[$team]['name'] . "</a></li>";
			if($team == $array_args['t_id'] && $array_args["l_name"] == $array_args["selected_league"])$display = "block";
		}

		if(count($groups_teams) == 1) $display = "block";

		$out .= "\n<div id='group_".$g_id."' style='display: $display;'>";
		$out .= "\n<ul>".$out_teams."\n</ul>";
		$out .= "\n</div>";
	}
	$out .= "</div>";

	$out .= "</div>";

	#dati
	if (!empty ($array_args['t_id']) && is_numeric($array_args['t_id']) && $array_args["l_name"] == $array_args["selected_league"]) {
		$out .= "\n<div id='data'>";
		$out .= $function ($array_args);
		$out .= "\n</div>";
	}

	return $out;

}

function get_players($pl_id = '', $extra = '') {

	$where = ($pl_id == '') ? '' : " where pl_id = $pl_id";
	$players = array ();
	$sql = "SELECT * FROM {fanta_players} " . $where. $extra;
	$result = db_query($sql) or die($sql . mysql_error());
	while ($row = db_fetch_object($result)) {
		$pl_id = $row->pl_id;
		$players[$pl_id] = $row;
	}
	return $players;

}

function get_next_round_formazione($l_id) {

	$sql = "SELECT max(round) FROM {league_matches} WHERE l_id = '%d' AND played = 1";
	$result = db_query($sql, $l_id);
	return (db_result($result) + 1);
}

function get_last_round_formazione($l_id) {

	$sql = "SELECT max(round) FROM {fanta_formazioni} WHERE l_id = '%d'";
	$result = db_query($sql, $l_id);
	return db_result($result);
}

function get_match($round, $t_id, $l_id) {

	$sql = "SELECT * FROM {league_matches} " .
	"WHERE l_id = '%d' " .
	"AND round = '%d' " .
	"AND (t1_id = '%d' OR t2_id = '%d')";
	$result = db_query($sql, $l_id, $round, $t_id, $t_id);
	return db_fetch_object($result);
//	return db_result($result);

}

function get_match_id($round, $t_id, $l_id) {
	$match = get_match($round, $t_id, $l_id);
	return $match->m_id;
}

function filter_teams_formazioni($array = array (), $args = array ()) {

	$l_id = (isset ($args['l_id']) && !empty ($args['l_id'])) ? $args['l_id'] : '1';

	$round = (isset ($args['round']) && !empty ($args['round'])) ? $args['round'] : get_last_round_formazione($l_id);

	$sql = "SELECT DISTINCT t_id FROM {fanta_formazioni} " .
	"WHERE l_id = '%d' " .
	"AND round = '%d'";
	$result = db_query($sql, $l_id, $round);
	$teams_ok = array ();
	while ($row = db_fetch_array($result)) {
		$teams_ok[] = $row['t_id'];
	}

	foreach ($array as $t_id => $team) {
		if (!in_array($t_id, $teams_ok))
			unset ($array[$t_id]);
	}

	return $array;
}

function change_round_and_league() {
	return '';
}

function show_posizione($posizione, $players) {

	$out = "";

	foreach ($posizione as $pl_id => $player){
		$roles[] = $players[$player->pl_id]->role;
		$names[] = $players[$player->pl_id]->name;
		$positions[] = $player->posizione;
	}

	array_multisort($roles, $positions, $names, $posizione);

	foreach ($posizione as $p_id => $player) {
		$out .= "\n<tr class='role_" . $players[$player->pl_id]->role . "'>";
		$out .= "\n<td>" . convert_ruolo($players[$player->pl_id]->role) . "</td>";
		$out .= "\n<td class='name'>" . $players[$player->pl_id]->name . "</td>";
		$out .= "\n<td>" . ucwords(convert_teams($players[$player->pl_id]->team)) . "</td>";

		$out .= "\n<td><a rel='lightframe[formazione]' href='".base_path()."scheda/giocatore/". $player->pl_id . "' class='thickbox' title='Dettagli giocatore'>" .
		"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>" .
		"</a></td>";

		$out .= "\n</tr>";

	}

	$out .= "<tr><td>&nbsp;</td></tr>";

	return $out;
}

function insert_formazione($league_name) {

	global $user;

	drupal_add_js('misc/ajax.js');
	drupal_add_css('sites/all/modules/fantacalcio/style.css', 'themes', 'all', FALSE);

	$u_id = $user->uid;

	$t_id = get_own_team_id($u_id);
	$l_id = get_league_id($league_name);
	$round = get_next_round_formazione($l_id);
	$match = get_match($round, $t_id, $l_id);
	$round_label = get_round_label($match);

	$out = '';

	$ts_match = get_timestamp_match($l_id, $round);

	#formazione inserita in orario
	if ($ts_match > time()) {

		#$out .= show_rosa($args);

		$js = "function a(){
					var sub = document.getElementById('submit');
					sub.disabled = false;
			}";
		drupal_add_js($js, 'inline');

		$out .= "\n<h3>" . ucwords($league_name) . "</h3>";
		$out .= "\n<h4>" . $round_label."</h4>";

		$args = array (
			't_id' => $t_id,
			'l_id' => $l_id,
			'round' => $round,
		);

		$formazione_form = drupal_get_form('fantacalcio_formazione_form', $args);

		$args_confirm = get_args_confirm($args);

		$out .= confirm_formazione($args_confirm);

		$validate = fantacalcio_formazione_validate($l_id, $round, $t_id);

		$out .= "\n<div id='validate'>" . $validate . "</div>";

		$out .= "\n<div id='formazione_form'>" . $formazione_form . "</div>";

		$out .= "\n<div class='clear' style='height:10px;'></div>";

		$out .= "\n<div id='formazione'>" .
		make_formazione($t_id, $l_id, $round) .
		"\n</div>";
	}
	else {
		fantacalcio_formazione_insert('old', $t_id, $l_id, $round);
		header("location: formazioni/".get_league_name($l_id)."/".$round."/".$t_id);
	}
	return $out;

}

function get_own_team_id($u_id) {
	$sql = "SELECT t_id FROM {league_teamusers} WHERE u_id = '%d' AND active = 1";
	$result = db_query($sql, $u_id);
	return db_result($result);
}

function get_last_votes() {

	$sql = "SELECT max(round) FROM {fanta_votes}";
	$result = db_query($sql);
	return db_result($result);
}

function get_last_league_round($l_id) {

	$vote_round = get_last_votes($l_id);
	$sql = "SELECT league_round FROM {fanta_votes_round} " .
	"WHERE l_id = '%d' " .
	"AND vote_round = '%d'";
	$result = db_query($sql, $l_id, $vote_round);
	return db_result($result);
}

function get_next_league_round($l_id) {

	$vote_round = get_last_votes($l_id);
	$sql = "SELECT league_round FROM {fanta_votes_round} " .
	"WHERE l_id = '%d' " .
	"AND vote_round = '%d'";
	$result = db_query($sql, $l_id, $vote_round +1);
	return db_result($result);
}

function fantacalcio_show_multe() {

	$out = '';
	$multe = array ();

	$sql = "SELECT * FROM {fanta_votes_round}";
	$result = db_query($sql);
	while ($row = db_fetch_object($result)) {
		$vote_rounds[$row->l_id][$row->league_round] = $row->vote_round;
	}

	$max_round = 0;
	$sql = "SELECT * FROM {fanta_formazioni_insert}";
	$result = db_query($sql);
	while ($row = db_fetch_object($result)) {
		$t_id = $row->t_id;
		$league_round = $row->round;
		$l_id = $row->l_id;

		$round = $vote_rounds[$l_id][$league_round];

		$multe[$t_id][$round] += ($row->status == 0) ? 1 : 0;
		$max_round = ($max_round < $round) ? $round : $max_round;
	}

	$num_multe = array(); $tot_multe = array();

	if ($multe) {

		$header[] = "Squadra";

		$teams = get_teams();

		foreach($teams as $t_id => $team){
			$key = ucwords($team['name']);
			$rows[$key][] = $team['name'];
		}

		$tot_multe = 0; $teams_round = array();

		foreach ($multe as $t_id => $multe_team) {

			$key = ucwords($teams[$t_id]['name']);

			foreach ($multe_team as $round => $multa) {

				if ($multa != 0) {
					$num_multe[$t_id]++;
					$rows[$key][] = "<img src='".base_path()."sites/default/files/images/no.png'>";
				}
				else $rows[$key][] = "<img src='".base_path()."sites/default/files/images/ok.png'>";

				$last_user_round = $round;

				$teams_round[$t_id]++;

				$header[$round] = $round;
			}

			$tot_multa[$t_id] = ($num_multe[$t_id]);

		}

		foreach($teams_round as $t_id => $team_round){
			$key = ucwords($teams[$t_id]['name']);
			for($i = $team_round; $i < $max_round; $i++) $rows[$key][] = " - ";

		}

		foreach($tot_multa as $t_id => $multa){
			$key = ucwords($teams[$t_id]['name']);
			$multa_team = fantacalcio_calcola_multe($multa);
			$rows[$key][] = $multa_team . " &euro;";
			$tot_multe += $multa_team;
		}

		$header[] = "Totale";

		ksort($rows);

		$rows['totale'] = array (
							array (
								"data" => "Totale",
								"colspan" => (1 + $max_round),
								"style" => "font-weight: bold;"
								),
							array(
								"data" => $tot_multe . " &euro;",
								"style" => "font-weight: bold;"
								)
							);

		return theme_table($header, $rows);
	}
	else return "Nessuna multa";

}

function fantacalcio_calcola_multe($num_multe) {
	#calcola la multa totale per ciascuna squadra
	return $num_multe * ($num_multe +1) / 2;
}

#formazioni della giornata di tutte le squadre
function get_formazioni_round($round) {

	$formazioni = array ();
	$players = get_players();

	$sql = "SELECT * FROM {fanta_formazioni} " .
	"WHERE round = '%d' " .
	"AND posizione > 0";
	$result = db_query($sql, $round);
	while ($row = db_fetch_array($result)) {
		$pl_id = $row['pl_id'];
		$t_id = $row['t_id'];
		$l_id = $row['l_id'];
		$formazioni[$l_id][$t_id][$pl_id] = $row;
		$formazioni[$l_id][$t_id][$pl_id]['role'] = $players[$pl_id]->role;
	}

	return $formazioni;
}

function get_votes($round) {

	$votes = array ();

	$sql = "SELECT * FROM {fanta_votes} " .
	"WHERE round = '%d' ";
	$result = db_query($sql, $round);
	while ($row = db_fetch_object($result)) {
		$pl_id = $row->pl_id;
		$votes[$pl_id] = $row;
	}

	return $votes;
}

function fantacalcio_team_form($form_state) {

	$team = get_team_data();
	$action = ($team) ? 'update' : 'insert';
	$title = ($team) ? 'Modifica squadra - '.$team['name'] : 'Crea squadra';
	drupal_set_title($title);

	$form['title'] = array (
		'#title' => $title
	);

	if(!$team){
	$form['name'] = array (
		'#type' => 'textfield',
		'#title' => 'Nome squadra',
		'#default_value' => $team['name'],
		'#required' => TRUE,

	);
	}

	$form['coach'] = array (
		'#type' => 'textfield',
		'#title' => 'Allenatore',
		'#default_value' => $team['coach'],

	);

	$form['stadium'] = array (
		'#type' => 'textfield',
		'#title' => 'Stadio',
		'#default_value' => $team['stadium'],

	);

	$form['shirt'] = array (
		'#type' => 'fieldset',
		'#title' => 'Divisa',
		'#ahah' => array (
			'wrapper' => 'prova',
				// default so not really needed, but included for clarity
	'method' => 'replace',
			'event' => 'change',
			'path' => 'js/divisa.js',

		),

	);

	$form['shirt']['type'] = array (
		'#type' => 'select',
		'#options' => array (
			0 => 'solo bordi',
			1 => 'righe verticali',
			2 => 'righe orizzontali',
			3 => 'banda diagonale'
		),
		'#title' => 'Tipo',
		'#default_value' => substr($team['shirt'],
		-9,
		1
	), '#ahah' => array (
		'wrapper' => 'shirt_preview',
			// default so not really needed, but included for clarity
	'method' => 'replace',
		'event' => 'change',
		'path' => 'team/js',

	),);

	$form['shirt']['color_1'] = array (
		'#type' => 'select',
		'#options' => array (
			0 => 'Bianco',
			1 => 'Nero',
			2 => 'Rosso',
			3 => 'Blu',
			4 => 'Verde',
			5 => 'Giallo'
		),
		'#title' => 'Colore 1',
		'#default_value' => substr($team['shirt'],
		-7,
		1
	), '#ahah' => array (
		'wrapper' => 'shirt_preview',
			// default so not really needed, but included for clarity
	'method' => 'replace',
		'event' => 'change',
		'path' => 'team/js',

	),);

	$form['shirt']['color_2'] = array (
		'#type' => 'select',
		'#options' => array (
			0 => 'Bianco',
			1 => 'Nero',
			2 => 'Rosso',
			3 => 'Blu',
			4 => 'Verde',
			5 => 'Giallo'
		),
		'#title' => 'Colore 2',
		'#default_value' => substr($team['shirt'],
		-5,
		1
	), '#ahah' => array (
		'wrapper' => 'shirt_preview',
			// default so not really needed, but included for clarity
	'method' => 'replace',
		'event' => 'change',
		'path' => 'team/js',

	),);

	$form['shirt']['preview'] = array (
		'#prefix' => "<div id='shirt_preview' style='float:left;'>",
		'#suffix' => "</div>",
		'#type' => 'markup',
		'#value' => "<img src='" . $team['shirt'] . "'>"
	);

	$form['t_id'] = array (
		'#type' => 'hidden',
		'#value' => $team['t_id'],

	);

	$form['action'] = array (
		'#type' => 'hidden',
		'#value' => $action,

	);

	$form['submit'] = array (
		'#type' => 'submit',
		'#value' => 'Ok'
	);

	$form['clear'] = array (
		'#type' => 'submit',
		'#value' => 'Annulla',
		'#validate' => array (
			'fantacalcio_squadra_form_clear'
		),

	);

	return $form;
}

function fantacalcio_team_form_ahah() {
	$type = $_POST['type'];
	$color_1 = $_POST['color_1'];
	$color_2 = $_POST['color_2'];

	$output = "<img src='sites/default/files/pictures/shirts/shirt_" . $type . "_" . $color_1 . "_" . $color_2 . ".png' border='1'>";
	print drupal_to_js(array (
		'data' => $output,
		'status' => true
	));
	exit ();
}

function fantacalcio_team_manager() {
	return drupal_get_form('fantacalcio_team_form');
}

function fantacalcio_team_form_clear($form, & $form_state) {
	$form_state['rebuild'] = TRUE;
}

function fantacalcio_team_form_validate($form, & $form_state) {
	$name = $form_state['values']['name'];
	if (!$name)
		form_set_error('name', 'Inserisci un nome per la squadra');
}

function fantacalcio_team_form_submit($form, & $form_state) {

	global $user;

	$team_name = $form_state['values']['name'];
	$team_coach = $form_state['values']['coach'];
	$team_stadium = $form_state['values']['stadium'];
	$team_shirt = "sites/default/files/pictures/shirts/shirt_" . $form_state['values']['type'] . "_" . $form_state['values']['color_1'] . "_" . $form_state['values']['color_2'] . ".png";
	$t_id = $form_state['values']['t_id'];
	$action = $form_state['values']['action'];

	if ($action == 'update') {

		$sql = "UPDATE {league_teams} " .
		"SET name = '%s', " .
		"coach = '%s', " .
		"stadium = '%s', " .
		"shirt = '%s' " .
		"WHERE t_id = '%d'";
		$result = db_query($sql, $team_name, $team_coach, $team_stadium, $team_shirt, $t_id);

		return drupal_set_message('Squadra modificata con successo');
	}
	elseif ($action == 'insert') {

		$sql = "INSERT INTO {league_teams} (name, coach, stadium, shirt, active) " .
		"VALUES ('%s', '%s', '%s', '%s', 1)";
		$result = db_query($sql, $team_name, $team_coach, $team_stadium, $team_shirt) or mysql_error();
		$t_id = db_last_insert_id('{league_teams}', 't_id');

		$sql = "INSERT INTO {league_teamusers} (u_id, t_id, active) " .
		"VALUES ('%d', '%d', 1)";
		$result = db_query($sql, $user->uid, $t_id);

		return drupal_set_message('Squadra creata con successo');
	}
}

function get_team_data() {

	global $user;

	$sql = "SELECT t_id FROM {league_teamusers} WHERE u_id = '%d' AND active = 1";
	$result = db_query($sql, $user->uid);
	$t_id = db_result($result);

	if ($t_id) {
		$sql = "SELECT * FROM {league_teams} WHERE t_id = '%d'";
		$result = db_query($sql, $t_id);
		return db_fetch_array($result);
	} else
		return array ();
}

function fantacalcio_get_title_team() {

	$team = get_team_data();

	if (count($team) == 0)
		return 'Crea Squadra';
	else
		return 'Modifica Squadra';
}

function get_matches_round($round) {

	$matches = array ();
	$sql = "SELECT * FROM {league_matches} WHERE round = '%d'";
	$result = db_query($sql, $round);
	while ($row = db_fetch_array($result)) {
		$m_id = $row['m_id'];
		$matches[$m_id] = $row;
	}

	return $matches;

}

function get_tail_round($l_id) {

	return get_last_round_formazione($l_id);
}

function get_round_formazioni($l_id) {

	$matches = get_matches();

	foreach($matches as $m_id => $match){
		if($match->l_id == $l_id)$round_labels[$match->round] = empty($match->round_label) ? $match->round : $match->round_label;
	}

	$rounds = array ();
	$sql = "SELECT DISTINCT round FROM {fanta_formazioni} WHERE l_id = '%d'";
	$result = db_query($sql, $l_id);
	while ($row = db_fetch_array($result)) {
		$rounds[$row["round"]] = $round_labels[$row["round"]];
	}

	krsort($rounds);

	return $rounds;

}

function fantacalcio_form_choose_round($form_state, $l_id) {

	$form['round'] = array (
		'#type' => 'select',
		'#options' => get_round_formazioni($l_id
	),);

	$form['l_id'] = array (
		'#type' => 'hidden',
		'#value' => $l_id,

	);

	#$form['submit'] = array('#type' => 'submit', '#value' => t('Carica'));

	return drupal_get_form($form);

}

function fantacalcio_show_teams() {

	$teams = get_teams();
	$team_users = get_team_users();
	$users = get_users();

	foreach($teams as $team)
		$teams_names[] = ucwords($team['name']);

	array_multisort($teams_names, SORT_ASC, $teams, SORT_DESC);

	if ($teams) {

		$header = array (
			array (
				"data" => "Nome",
				"colspan" => 2
			),
			"Allenatore",
			"Stadio",
			"User",
			""
		);

		foreach ($teams as $t_id => $team) {

			$u_id = $team_users[$team['t_id']]->u_id;

			$rows[$u_id] = array (
				"<img src='" . base_path() . $team['shirt'] . "'>",
				$team['name'],
				$team['coach'],
				$team['stadium'],
				l($users[$u_id]->name, "user/" . $u_id)
			);
		}
	}

	return theme_table($header, $rows);

}

function get_users() {

	$users = array ();
	$sql = "SELECT * FROM {users}";
	$result = db_query($sql);
	while ($row = db_fetch_object($result)) {
		$u_id = $row->uid;
		$users[$u_id] = $row;
	}

	return $users;
}

function get_team_users() {

	$team_users = array ();
	$sql = "SELECT * FROM {league_teamusers} WHERE active = 1";
	$result = db_query($sql);
	while ($row = db_fetch_object($result)) {
		$t_id = $row->t_id;
		$team_users[$t_id] = $row;
	}

	return $team_users;
}

function fantacalcio_formazione_form($form_state, $args) {

	global $user;

	$form['#redirect'] = 'formazioni/'.get_league_name($args['l_id']).'/'.$args['round'].'/'.$args['t_id'] ;

	if ($args['status'] == 1)
		$disabled = FALSE;
	else
		$disabled = TRUE;

	$form['t_id'] = array (
		'#type' => 'hidden',
		'#value' => $args['t_id']
	);

	$form['l_id'] = array (
		'#type' => 'hidden',
		'#value' => $args['l_id']
	);

	$form['round'] = array (
		'#type' => 'hidden',
		'#value' => $args['round']
	);
	/*
	    $form['submit'] = array(
		    '#type' => 'submit',
		    '#value' => 'Invia',
		    '#weight' => 1,
		    '#submit' => array('my_form_submit'),//none JS version
		    '#ahah' => array(
		      'event' => 'click',
		      'path' => 'formazioni/validate/'.$args['l_id'].'/'.$args['round'],
		      'wrapper' => 'prova',
		      'method' => 'replace',
		      'effect' => 'fade',
		      'progress' => array(
		        'type' => 'throbber',
		        'message' => t('Loading...')
		      ))
	    );
	    */

	$form['submit'] = array (
		'#type' => 'submit',
		'#value' => 'Invia',
		'#weight' => -1,
		'#validate' => array('fantacalcio_formazione_form_validate'),
		#'#disabled' => $disabled,

	);

	$form['clear'] = array (
		'#type' => 'submit',
		'#value' => 'Cancella',
		'#validate' => array (
			'fantacalcio_formazione_form_clear'
		),
		'#attributes' => array (
			'onclick' => "return confirm_reset_formazione()"
		),


	);

	return $form;
}

function fantacalcio_formazione_form_submit($form, & $form_state) {

	$t_id = $form_state['values']['t_id'];
	$l_id = $form_state['values']['l_id'];
	$round = $form_state['values']['round'];

	$ts_match = get_timestamp_match($l_id, $round);

	#formazione inviata in orario
	if ($ts_match > time()) {
		fantacalcio_formazione_insert('new', $t_id, $l_id, $round);
		if(check)
		drupal_set_message('Formazione inserita correttamente.');
	}
	#formazione inviata in ritardo -> giornata precedente
	else {
		#if()
		fantacalcio_formazione_insert('old', $t_id, $l_id, $round);
		drupal_set_message('Tempo scaduto. Userai la formazione della giornata precedente');
	}

	return;
}

function fantacalcio_formazione_form_clear($form, & $form_state) {

	#cancella la formazione inserita
	$sql = "DELETE FROM {fanta_formazioni} " .
	"WHERE l_id = '%d' " .
	"AND round = '%d' " .
	"AND t_id = '%d'";
	$result = db_query($sql, $form_state['values']['l_id'], $form_state['values']['round'], $form_state['values']['t_id']);

	$sql = "DELETE FROM {fanta_formazioni_insert} " .
			"WHERE l_id = '%d' " .
			"AND round = '%d' " .
			"AND t_id = '%d'";
	$result = db_query($sql, $form_state['values']['l_id'], $form_state['values']['round'], $form_state['values']['t_id']);

	drupal_set_message('Formazione cancellata');
	return $form_state['rebuild'] = TRUE;
}

function fantacalcio_formazione_validate($l_id, $round, $t_id) {
	$players = get_players();

	$formazione = array();
	$sql = "SELECT * FROM drupal_fanta_formazioni " .
			"WHERE t_id = $t_id " .
			"AND l_id = $l_id " .
			"AND round = $round ";
	$result = db_query($sql);
	while($row = db_fetch_array($result)){
		$pl_id = $row['pl_id'];
		$formazione[$pl_id] = $row;
	}

	$num_titolari = 0; $num_riserve = 0;
	$num_portieri = 0; $num_difensori = 0; $num_centrocampisti = 0; $num_attaccanti = 0;
	$num_portieri_ris = 0; $num_difensori_ris = 0; $num_centrocampisti_ris = 0; $num_attaccanti_ris = 0;
	$riserve = array();
	foreach($formazione as $pl_id => $player){
		if($player['posizione'] == 1){
			$num_titolari++;
			switch($players[$pl_id]->role){
				case 0:
					$num_portieri++;
					break;
				case 1:
					$num_difensori++;
					break;
				case 2:
					$num_centrocampisti++;
					break;
				case 3:
					$num_attaccanti++;
					break;
			}
		}

		elseif($player['posizione'] > 1){
			$num_riserve++;
			switch($players[$pl_id]->role){
				case 0:
					$num_portieri_ris++;
					break;
				case 1:
					$num_difensori_ris++;
					break;
				case 2:
					$num_centrocampisti_ris++;
					break;
				case 3:
					$num_attaccanti_ris++;
					break;
			}
		}

	}

	$modulo = array($num_portieri, $num_difensori, $num_centrocampisti, $num_attaccanti);
	$modulo_ris = array($num_portieri_ris, $num_difensori_ris, $num_centrocampisti_ris, $num_attaccanti_ris);
	$array_moduli = array(
						array(1,3,4,3),
						array(1,3,5,2),
						array(1,4,3,3),
						array(1,4,4,2),
						array(1,4,5,1),
						array(1,5,3,2),
						array(1,5,4,1),
						array(1,6,3,1)
						);
	$array_moduli_ris = array(
						array(1,2,2,2)
						);

	$out = "\n<ul>";

	#num titolari
	$out .= "\n<li>Numero Titolari: ".fantacalcio_formazione_verifica($num_titolari, 11)."</li>";
	#modulo titolari
	$out .= "\n<li>Modulo: ".fantacalcio_formazione_verifica($modulo, $array_moduli)."</li>";
	#num riserve
	$out .= "\n<li>Numero Riserve: ".fantacalcio_formazione_verifica($num_riserve, 7)."</li>";
	#modulo riserve
	$out .= "\n<li>Ruolo Riserve: ".fantacalcio_formazione_verifica($modulo_ris, $array_moduli_ris)."</li>";

	$out .= "\n</ul>";

	$out .= "<div class='clear'></div>";

	$status = 0;

	$args = array('t_id' => $t_id, 'l_id' => $l_id, 'round' => $round, 'status' => $status);

	$out .= "<div id='formazione-form'></div>";

	return $out;

}

function get_timestamp_match($l_id, $round) {
	$sql = "SELECT DISTINCT date FROM {league_matches} " .
	"WHERE l_id = '%d' " .
	"AND round = '%d'";
	$result = db_query($sql, $l_id, $round);
	$d = db_result($result);
	return mktime(substr($d, 11, 2), substr($d, 14, 2), substr($d, 17, 2), substr($d, 5, 2), substr($d, 8, 2), substr($d, 0, 4));
}

function make_formazione($t_id, $l_id, $round) {

	global $user;

	drupal_add_css('sites/all/plugins/interface/interface.css', 'themes', 'all', FALSE);
	drupal_add_js('sites/all/plugins/interface/interface.js');
	drupal_add_js('sites/all/plugins/interface/compressed/idrag.js');
	drupal_add_js('sites/all/plugins/interface/compressed/idrop.js');
	drupal_add_js('sites/all/plugins/interface/compressed/isortables.js');
	drupal_add_js('sites/all/modules/fantacalcio/js/insformazione.js');

	$players = get_players();

	$formazione = array ();
	$titolari = array ();
	$riserve_1 = array ();
	$riserve_2 = array ();
	$sql = "SELECT * FROM {fanta_formazioni} " .
	"WHERE round = '%d' " .
	"AND l_id = '%d' " .
	"AND t_id = '%d' " .
	"AND posizione != 0";
	$result = db_query($sql, $round, $l_id, $t_id);
	while ($row = db_fetch_array($result)) {
		$formazione[$row['pl_id']] = $row;
		if ($row['posizione'] == 1)
			array_push($titolari, $row);
		elseif ($row['posizione'] == 2) array_push($riserve_1, $row);
		elseif ($row['posizione'] >= 3) array_push($riserve_2, $row);
	}

	$sql = "SELECT * FROM {fanta_rose} WHERE t_id = $t_id AND in_squadra = 1";
	$result = db_query($sql) or die($sql . mysql_error());
	while ($row = db_fetch_array($result)) {
		$rose[] = $row;
	}

	foreach($rose as $rosa){
		$roles[] = $players[$rosa['pl_id']]->role;
		$names[] = $players[$rosa['pl_id']]->name;
	}

	array_multisort($roles, SORT_ASC, $names, SORT_ASC, $rose);

	#rosa
	foreach ($rose as $player) {
		if (!array_key_exists($player['pl_id'], $formazione)) {
			$pl_id = $player['pl_id'];
			$rosa[$pl_id] = $player;

			$class = "role_" . $players[$pl_id]->role;

			$out_rosa .= "\n<div  class='groupItem' id='$pl_id' name='" . $players[$pl_id]->role . "_" . $l_id . "_" . $t_id . "'>" .
			"\n<div  class='itemHeader'>\n" .
			"\n<table width='100%'>" .
			"\n<tr class='$class'>" .
			"\n<td width='10%'>" . convert_ruolo($players[$pl_id]->role) . "</td>" .
			"\n<td width='50%'>" . $players[$pl_id]->name . "</td>" .
			"\n<td width='35%'>" . $players[$pl_id]->team . "</td>" .
			"\n<td><a rel='lightframe[".$t_id."|width:770px;]' href='".base_path()."scheda/giocatore/".$pl_id."' title='Dettagli giocatore'>" .
			"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>" .
			"</a></td>".
			"\n</tr>" .
			"\n</table>" .
			"\n</div>"
			#."\n<div class='itemContent'>\n"
			#	."\n</div>"
			 . "\n</div>";
		}
	}

	#titolari
	$roles = array(); $names = array();
	foreach($titolari as $titolare){
		$roles[] = $players[$titolare['pl_id']]->role;
		$names[] = $players[$titolare['pl_id']]->name;
	}

	array_multisort($roles, SORT_ASC, $names, SORT_ASC, $titolari);

	foreach ($titolari as $titolare) {
		$pl_id = $titolare['pl_id'];
		$class = "role_" . $players[$pl_id]->role;

		$out_titolari .= "\n<div  class='groupItem' id='$pl_id' name='" . $players[$pl_id]->role . "_" . $l_id . "_" . $t_id . "'>" .
		"\n<div  class='itemHeader'>\n" .
		"\n<table width='100%'>" .
		"\n<tr class='$class'>" .
		"\n<td width='10%'>" . convert_ruolo($players[$pl_id]->role) . "</td>" .
		"\n<td width='50%'>" . $players[$pl_id]->name . "</td>" .
		"\n<td width='35%'>" . ucwords($players[$pl_id]->team) . "</td>" .
		"\n<td width='5%' style='padding-left:5px;'>".
		"\n<td><a rel='lightframe[".$t_id."|width:770px;]' href='".base_path()."scheda/giocatore/".$pl_id."' title='Dettagli giocatore'>" .
		"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>" .
		"</a></td>".
		"\n</td>" .
		"\n</tr>" .
		"\n</table>" .
		"\n</div>"
		#."\n<div class='itemContent'>\n"
		#	."\n</div>"
		 . "\n</div>";

	}

	#riserve
	$riserve = array_merge($riserve_1, $riserve_2);

	$roles = array(); $names = array(); $positions = array();
	foreach($riserve as $riserva){
		$roles[] = $players[$riserva['pl_id']]->role;
		$names[] = $players[$riserva['pl_id']]->name;
		$positions[] = $riserva['posizione'];
	}

	array_multisort($roles, SORT_ASC, $positions, SORT_ASC, $names, SORT_ASC, $riserve);

	foreach ($riserve as $riserva) {
		$pl_id = $riserva['pl_id'];
		$class = "role_" . $players[$pl_id]->role;

		$out_riserve .= "\n<div  class='groupItem' id='$pl_id' name='" . $players[$pl_id]->role . "_" . $l_id . "_" . $t_id . "'>" .
		"\n<div  class='itemHeader'>\n" .
		"\n<table width='100%'>" .
		"\n<tr class='$class'>" .
		"\n<td width='10%'>" . convert_ruolo($players[$pl_id]->role) . "</td>" .
		"\n<td width='50%'>" . $players[$pl_id]->name . "</td>" .
		"\n<td width='35%'>" . ucwords($players[$pl_id]->team) . "</td>" .
		"\n<td width='5%' style='padding-left:5px;'>".
		"\n<td><a rel='lightframe[".$t_id."|width:770px;]' href='".base_path()."scheda/giocatore/".$pl_id."' title='Dettagli giocatore'>" .
		"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>" .
		"</a></td>".
		"\n</td>" .
		"\n</tr>" .
		"\n</table>" .
		"\n</div>"
		#."\n<div class='itemContent'>\n"
		#."\n</div>"
		 . "\n</div>";

	}

	$out = "";

	#rosa
	$out .= "<div id='pos_0' class='groupWrapper'>" .
	$out_rosa .
	"</div>";

	#titolari
	$out .= "<div id='pos_1' class='groupWrapper'>" .
	"<h4>Titolari</h4>" .
	$out_titolari .
	"</div>";

	#riserve
	$out .= "<div id='pos_2' class='groupWrapper'>" .
	"<h4>Riserve</h4>" .
	$out_riserve .
	"</div>";

	return $out;
}

function fantacalcio_insert_formazione($league_name = '') {

	global $user;

	$leagues = get_leagues();
	$teams = get_teams();

	$t_id = get_team_id($user->uid);

	if (empty ($league_name) || !is_league($league_name)) {

		#controllo quante formazioni vanno inserite per la giornata
		$vote_round = get_last_votes() or 0;
		$vote_round++;
		$sql = "SELECT * FROM {fanta_votes_round} WHERE vote_round = '%d'";
		$result = db_query($sql, $vote_round);
		while($row = db_fetch_array($result)){
			$sqla = "SELECT * FROM {league_matches} " .
					"WHERE l_id = '%d' " .
					"AND round = '%d' " .
					"AND (t1_id = '%d' OR t2_id = '%d')";
			$resulta = db_query($sqla, $row['l_id'], $row['league_round'], $t_id, $t_id);
			while($rowa = db_fetch_array($resulta)){
				$formazioni[$rowa['l_id']] = $rowa['round'];
			}
		}

		if(count($formazioni) > 1){
			$out = "<p>Inserire una formazione per ogni partita</p>";
			foreach($formazioni as $l_id => $round){

				$league = $leagues[$l_id];

				$insert = check_formazione_insert($t_id, $l_id, $round);
				$opponent = get_opponent($t_id, $l_id, $round);
				$match = get_match($round, $t_id, $l_id);
				$opponent_link = l($teams[$opponent]['name'], "formazioni/".$league->name."/".$round."/".$opponent, array("attributes" => array("title" => "Formazione ".$teams[$opponent]["name"])) );

				$round_label = (empty($match->round_label)) ? $round."&ordf; Giornata" : $match->round_label;

				$rows[$l_id][] = "<a href='".base_path().arg(0)."/".$league->name."'>".$league->name." (".$round_label.")</a>";
				$rows[$l_id][] = "<span class='insert'>".$insert."</span>";
				$rows[$l_id][] = "<span class='opponent'>".$teams[$t_id]["name"]." - ".$opponent_link."</span>";
			}

			$out .= "<div style='width: 70%;'>".theme_table(array(), $rows, array())."</div>";

			return $out;
		}
		elseif(count($formazioni) == 1) {
			foreach($formazioni as $l_id => $round) $league_name = $leagues[$l_id]->name;

			return insert_formazione($league_name);
		}
	}

	else return insert_formazione($league_name);

}

function fantacalcio_formazione_form_validate($form, &$form_state) {

	$l_id = $form_state["values"]["l_id"];
	$round = $form_state["values"]["round"];
	$t_id = $form_state["values"]["t_id"];

	$players = get_players();

	$formazione = array ();
	$sql = "SELECT * FROM drupal_fanta_formazioni " .
	"WHERE t_id = $t_id " .
	"AND l_id = $l_id " .
	"AND round = $round ";
	$result = db_query($sql);
	while ($row = db_fetch_array($result)) {
		$pl_id = $row['pl_id'];
		$formazione[$pl_id] = $row;
	}

	$num_titolari = 0;
	$num_riserve = 0;
	$num_portieri = 0;
	$num_difensori = 0;
	$num_centrocampisti = 0;
	$num_attaccanti = 0;

	$modulo = array(0 => 0, 1 => 0, 2 => 0, 3 => 0);
	$modulo_ris = array(0 => 0, 1 => 0, 2 => 0, 3 => 0);

	$num_portieri_ris = 0;
	$num_difensori_ris = 0;
	$num_centrocampisti_ris = 0;
	$num_attaccanti_ris = 0;
	$riserve = array ();
	foreach ($formazione as $pl_id => $player) {
		if ($player['posizione'] == 1) {
			$num_titolari++;
			$modulo[$players[$pl_id]->role]++;
			/*switch ($players[$pl_id]->role) {
				case 0 :
					$num_portieri++;
					break;
				case 1 :
					$num_difensori++;
					break;
				case 2 :
					$num_centrocampisti++;
					break;
				case 3 :
					$num_attaccanti++;
					break;
			}*/
		}

		elseif ($player['posizione'] > 1) {
			$num_riserve++;
			$modulo_ris[$players[$pl_id]->role]++;
			/*
			switch ($players[$pl_id]->role) {
				case 0 :
					$num_portieri_ris++;
					break;
				case 1 :
					$num_difensori_ris++;
					break;
				case 2 :
					$num_centrocampisti_ris++;
					break;
				case 3 :
					$num_attaccanti_ris++;
					break;
			}
			*/
		}

	}

	/*
	$modulo = array (
		$num_portieri,
		$num_difensori,
		$num_centrocampisti,
		$num_attaccanti
	);
	$modulo_ris = array (
		$num_portieri_ris,
		$num_difensori_ris,
		$num_centrocampisti_ris,
		$num_attaccanti_ris
	);
	*/

	$array_moduli = array (
		array (
			1,
			3,
			4,
			3
		),
		array (
			1,
			3,
			5,
			2
		),
		array (
			1,
			4,
			3,
			3
		),
		array (
			1,
			4,
			4,
			2
		),
		array (
			1,
			4,
			5,
			1
		),
		array (
			1,
			5,
			3,
			2
		),
		array (
			1,
			5,
			4,
			1
		),
		array (
			1,
			6,
			3,
			1
		)
	);
	$array_moduli_ris = array (
		array (
			1,
			2,
			2,
			2
		)
	);

	$errors = 0;


	if ($num_titolari != 11) form_set_error("", "Numero titolari errato");

	if(!in_array($modulo, $array_moduli)) form_set_error("", "Modulo non consentito");

	if ($num_riserve != 7) form_set_error("", "Numero riserve errato");

	if(!in_array($modulo_ris, $array_moduli_ris)) form_set_error("", "Ruolo riserve errato");

}

function fantacalcio_formazione_verifica($value, $check) {

	if (is_array($value)) {
		if (in_array($value, $check))
			return "<img src='/sites/all/themes/waffles/images/mini-check.gif'>";
		else
			return "<img src='/sites/all/themes/waffles/images/no.png'>";
	} else {
		if ($check == $value)
			return "<img src='/sites/all/themes/waffles/images/mini-check.gif'>";
		else
			return "<img src='/sites/all/themes/waffles/images/no.png'>";
	}

}

function fantacalcio_formazione_insert($type = 'new', $t_id, $l_id, $round, $other_l_id = '', $other_round = '', $status = 1) {

	$status = ($status + 1 ) % 2;

	if ($type == 'new') {
		#registrazione formazione

		db_query("DELETE FROM {fanta_formazioni_insert} WHERE t_id = $t_id AND l_id = $l_id AND round = $round");

		$sql = "INSERT INTO {fanta_formazioni_insert} (t_id, l_id, round, status, ts) VALUES ($t_id, $l_id, $round, 1, " . time() . ")";
		$result = db_query($sql);
	}
	elseif ($type == 'old') {

		if(fantacalcio_formazione_exists($t_id, $l_id, $round)){
			drupal_set_message("Hai già inserito la formazione");
		}
		else{
			#registrazione formazione
			$sql = "INSERT INTO {fanta_formazioni_insert} (t_id, l_id, round, status, ts) VALUES ($t_id, $l_id, $round, 0, " . time() . ")";
			$result = db_query($sql);

			#inserimento formazione giornata precedente
			$sql = "SELECT * FROM {fanta_formazioni} WHERE l_id = '%d' AND t_id='%d' AND round = '%d'";
			$result = db_query($sql, $l_id, $t_id, $round -1);
			while ($row = db_fetch_array($result)) {
				$pl_id = $row['pl_id'];
				$position = $row['posizione'];
				$sqla = "INSERT INTO {fanta_formazioni} (pl_id, l_id, t_id, round, posizione) VALUES " .
				"($pl_id, $l_id, $t_id, $round, $position)";
				$resulta = db_query($sqla);
			}
			drupal_set_message("Userai la formazione della giornata precedente");
		}
	}
	elseif($type == 'confirm'){

		#registrazione formazione
		db_query("DELETE FROM {fanta_formazioni_insert} WHERE t_id = $t_id AND l_id = $l_id AND round = $round");

		$sql = "INSERT INTO {fanta_formazioni_insert} (t_id, l_id, round, status, ts) VALUES ($t_id, $l_id, $round, $status, " . time() . ")";
		$result = db_query($sql);

		#inserimento formazione giornata precedente
		$sql = "DELETE FROM {fanta_formazioni} " .
				"WHERE l_id = '%d' " .
				"AND round = '%d' " .
				"AND t_id = '%d'";
		$result = db_query($sql, $l_id, $round, $t_id);

		$sql = "SELECT * FROM {fanta_formazioni} WHERE l_id = '%d' AND t_id='%d' AND round = '%d'";
		$result = db_query($sql, $other_l_id, $t_id, $other_round);
		while ($row = db_fetch_array($result)) {
			$pl_id = $row['pl_id'];
			$position = $row['posizione'];
			$sqla = "INSERT INTO {fanta_formazioni} (pl_id, l_id, t_id, round, posizione) VALUES " .
			"($pl_id, $l_id, $t_id, $round, $position)";
			$resulta = db_query($sqla);
		}
		drupal_set_message("Formazione confermata");
	}
}

function check_formazione($form_state) {

	$players = get_players();

	$t_id = $form_state['values']['t_id'];
	$l_id = $form_state['values']['l_id'];
	$round = $form_state['values']['round'];

	$formazione = array ();
	$sql = "SELECT * FROM drupal_fanta_formazioni " .
	"WHERE t_id = $t_id " .
	"AND l_id = $l_id " .
	"AND round = $round ";
	$result = db_query($sql);
	while ($row = db_fetch_array($result)) {
		$pl_id = $row['pl_id'];
		$formazione[$pl_id] = $row;
	}

	$num_titolari = 0;
	$num_riserve = 0;
	$num_portieri = 0;
	$num_difensori = 0;
	$num_centrocampisti = 0;
	$num_attaccanti = 0;
	$num_portieri_ris = 0;
	$num_difensori_ris = 0;
	$num_centrocampisti_ris = 0;
	$num_attaccanti_ris = 0;
	$riserve = array ();
	foreach ($formazione as $pl_id => $player) {
		if ($player['posizione'] == 1) {
			$num_titolari++;
			switch ($players[$pl_id]->role) {
				case 0 :
					$num_portieri++;
					break;
				case 1 :
					$num_difensori++;
					break;
				case 2 :
					$num_centrocampisti++;
					break;
				case 3 :
					$num_attaccanti++;
					break;
			}
		}

		elseif ($player['posizione'] > 1) {
			$num_riserve++;
			switch ($players[$pl_id]->role) {
				case 0 :
					$num_portieri_ris++;
					break;
				case 1 :
					$num_difensori_ris++;
					break;
				case 2 :
					$num_centrocampisti_ris++;
					break;
				case 3 :
					$num_attaccanti_ris++;
					break;
			}
		}

	}

	$modulo = array (
		$num_portieri,
		$num_difensori,
		$num_centrocampisti,
		$num_attaccanti
	);
	$modulo_ris = array (
		$num_portieri_ris,
		$num_difensori_ris,
		$num_centrocampisti_ris,
		$num_attaccanti_ris
	);
	$array_moduli = array (
		array (
			1,
			3,
			4,
			3
		),
		array (
			1,
			3,
			5,
			2
		),
		array (
			1,
			4,
			3,
			3
		),
		array (
			1,
			4,
			4,
			2
		),
		array (
			1,
			4,
			5,
			1
		),
		array (
			1,
			5,
			3,
			2
		),
		array (
			1,
			5,
			4,
			1
		),
		array (
			1,
			6,
			3,
			1
		)
	);
	$array_moduli_ris = array (
		array (
			1,
			2,
			2,
			2
		)
	);

	$errors = 0;

	if (!fantacalcio_formazione_verifica($num_titolari, 11)) {
		$errors++;
	}

	if (!fantacalcio_formazione_verifica($modulo, $array_moduli)) {
		$errors++;
	}

	if (!fantacalcio_formazione_verifica($num_riserve, 7)) {
		$errors++;
	}

	if (!fantacalcio_formazione_verifica($modulo_ris, $array_moduli_ris)) {
		$errors++;
	}

	if ($errors == 0)
		return true;
	else
		return false;

}

function filter_team_group($teams, $g_id){

	$group_teams = array();
	$sql = "SELECT t_id FROM {league_leaguesteams} WHERE g_id = '%d'";
	$result = db_query($sql, $g_id);
	while($row = db_fetch_array($result)){
		$group_teams[] = $row['t_id'];
	}

	$filtered_teams = array();
	foreach($teams as $team){
		if(in_array($team['t_id'], $group_teams)) $filtered_teams[] = $team;
	}

	return $filtered_teams;
}

function fantacalcio_formazione_exists($t_id, $l_id, $round){

	$sql = "SELECT * FROM {fanta_formazioni} " .
			"WHERE t_id = '%d' " .
			"AND l_id = '%d' " .
			"AND round = '%d'";
	$result = db_query($sql, $t_id, $l_id, $round);
	if(db_affected_rows($result) > 0) return TRUE;
	else return FALSE;

}

function get_last_formazioni($l_id){
	$sql = "SELECT MAX(round) FROM {fanta_formazioni} " .
			"WHERE l_id = '%d'";
	$result = db_query($sql, $l_id);
	return db_result($result);
}

function get_team_id($u_id){
	$sql = "SELECT t_id FROM {league_teamusers} WHERE u_id = '%d'";
	$result = db_query($sql, $u_id);
	return db_result($result);
}

function fantacalcio_giocatori_liberi($g_id = ""){

	drupal_add_js('sites/all/plugins/jquery.tabs/jquery.tabs.js');
	drupal_add_css('sites/all/plugins/jquery.tabs/jquery.tabs.css', 'themes', 'all', FALSE);
	#drupal_add_css('sites/all/modules/league/league.css', 'themes', 'all', FALSE);
	$js = "$(function(){
			$('#roles').tabs({fxFade:true});
			});
			";
	drupal_add_js($js, 'inline');

	$sql = "SELECT * FROM {league_groups} WHERE l_id = 1";
	$result = db_query($sql);
	while($row = db_fetch_array($result)){
		$groups[$row['g_id']] = $row['name'];
	}

	$out = choose_group($groups);

	if(!empty($g_id) && is_group($g_id)){

		$out .= "<h3>".$groups[$g_id]."</h3>";

		$players = get_players('', "ORDER BY role, name");

		$nonfree_players = array(); $roles = array();
		$sql = "SELECT pl_id FROM {fanta_rose} WHERE t_id IN " .
				"(SELECT t_id FROM {league_leaguesteams} WHERE g_id = '%d') " .
				"AND in_squadra = 1";
		$result = db_query($sql, $g_id);
		while($row = db_fetch_array($result)){
			$nonfree_players[] = $row['pl_id'];
		}

		#tab per ogni ruolo
		$roles = array(0 => 0, 1 => 1, 2 => 2, 3 => 3);

		$out .= "\n<div id='roles'>" .
				"\n<ul>";
		foreach($roles as $role_id => $role){
			$out .= "\n<li style='background:none;'><a href='#r_".$role_id."'><span>".convert_ruolo($role, "long")."</span></a></li>";
		}
		$out .= "\n</ul>";

		foreach($roles as $role_id => $role){
			$out .= "\n<div id='r_".$role_id."'>"
					.get_free_players($role_id, $g_id, $players, $nonfree_players)
					."\n</div>";
		}

		$out .= "\n</div>";

	}

	return $out;
}

function choose_group($groups){

	return drupal_get_form("choose_group_form", $groups);

}

function is_group($g_id){
	$sql = "SELECT * FROM {league_groups} WHERE l_id = 1 AND g_id = '%d'";
	$result = db_query($sql, $g_id);
	if(count($result) > 0) return true;
	return false;
}

function choose_group_form(&$form_state,$groups){
	$form['groups'] = array("#type" => "fieldset");

	$form['groups']['groups'] = array(
									"#type" => "select",
									"#title" => "Scegli un girone",
									"#options"=> $groups,
									"#default_value" => $form_state['values']['groups'],
										);

	$form['groups']['submit'] = array(
									"#value" => "Ok",
									"#type" => "submit",
									);
	return $form;
}

function choose_group_form_submit($form, $form_state){

	#print_r($form_state);

	$g_id = $form_state['values']['groups'];
	drupal_goto("giocatori/liberi/".$g_id);

}

function get_free_players($role, $g_id, $players, $nonfree_players){

	$header[] = array("Ruolo");
	$header[] = array("Nome");
	$header[] = array("Squadra");
	$header[] = array("");

	$rows = array();

	foreach($players as $pl_id => $player){
		if(!in_array($pl_id, $nonfree_players) && $player->role == $role){
			$link_pl_id = "<a rel='lightframe[".$role."]' href='".base_path()."scheda/giocatore/".$pl_id."' title='Dettagli giocatore'>" .
						"<img src='" . base_path() . path_to_theme() . "/images/dettagli.png'>";
			$rows[$pl_id] = array(convert_ruolo($player->role), $player->name, ucwords(convert_teams($player->team)), $link_pl_id);
		}
	}

	$out .= theme_table($header, $rows);

	return $out;
}

function confirm_formazione($args){

	$t_id = $args["t_id"];
	$round = $args["round"];
	$l_id = $args["l_id"];

	if(!isset($args["other_l_id"]) or !isset($args["other_round"])){

		$sql = "SELECT vote_round FROM {fanta_votes_round} WHERE l_id = '%d' AND league_round = '%d'";
		$result = db_query($sql, $l_id, $round);
		$vote_round = db_result($result);
		$sql = "SELECT * FROM {fanta_votes_round} WHERE vote_round = '%d' AND l_id != '%d'";
		$result = db_query($sql, $vote_round, $l_id);
		while($row = db_fetch_array($result)){
			$other_l_id = $row['l_id'];
			$other_round = $row['league_round'];
		}
	}
	else {
		$other_l_id = $args["other_l_id"];
		$other_round = $args["other_round"];
	}

	$sql = "SELECT * FROM {fanta_formazioni_insert} " .
			"WHERE l_id = '%d' " .
			"AND round = '%d' " .
			"AND t_id = '%d'";
	$result = db_query($sql, $other_l_id, $other_round, $t_id);
	if(db_affected_rows($result) > 0){
		$args = array("t_id" => $t_id,
						"other_l_id" => $other_l_id,
						"other_round" => $other_round,
						"other_league_name" => get_league_name($other_l_id),
						"l_id" => $l_id,
						"league_name" => get_league_name($l_id),
						"round" => $round);

		if(arg(0) == "formazione" && arg(1) == "admin") $args["is_admin"] = 1;

		return "<div style='border: 1px solid #CCC; margin: 10px; padding: 5px;'>"
				."\n<div style='float:left;'>Vuoi utilizzare la stessa formazione che hai gi&agrave; inserito per la partita di ".$args['other_league_name']." (".$args['other_round']."&ordf; Giornata) ?</div>"
				."\n<div style='float:left; margin-left: 20px;'>".drupal_get_form("confirm_formazione_form", $args)."</div><div class='clear'></div></div>";
	}
	else return "";

}

function confirm_formazione_form($form_state, $args){

	$form["#redirect"] = "formazioni/".$args['league_name']."/".$args['round']."/".$args['t_id'];

	$form['other_l_id'] = array("#type" => "hidden", "#value" => $args['other_l_id']);
	$form['other_round'] = array("#type" => "hidden", "#value" => $args['other_round']);
	$form['l_id'] = array("#type" => "hidden", "#value" => $args['l_id']);
	$form['round'] = array("#type" => "hidden", "#value" => $args['round']);
	$form['t_id'] = array("#type" => "hidden", "#value" => $args['t_id']);

	if(isset($args['is_admin']) && $args['is_admin'] == 1){
		$form['multa'] = array("#type" => "checkbox", "#title" => "Multa");
	}
	else $form['multa'] = array("#type" => "hidden", "#value" => 0);

	$form['confirm']['submit'] = array(
							"#type" => "submit",
							"#value" => "Ok",
							"#title" => "conferma la formazione inserita"
							);

	return $form;

}

function confirm_formazione_form_submit($form, $form_state){

	#echo $form_state['values']['multa'];die();

	fantacalcio_formazione_insert('confirm', $form_state['values']['t_id'], $form_state['values']['l_id'], $form_state['values']['round'], $form_state['values']['other_l_id'], $form_state['values']['other_round'], $form_state['values']['multa']);

}


function is_team($t_id){
	$result = db_query("SELECT * FROM {league_teams} WHERE t_id = '%d'", $t_id);
	if(db_affected_rows($result) == 1) return TRUE;
	return FALSE;
}


function get_args_confirm($args){

	$t_id = $args['t_id'];
	$round = $args['round'];
	$l_id = $args['l_id'];

	$new_args = $args;

	$sql = "SELECT vote_round FROM {fanta_votes_round} WHERE l_id = '%d' AND league_round = '%d'";
	$result = db_query($sql, $l_id, $round);
	$vote_round = db_result($result);

	$sql = "SELECT * FROM {fanta_votes_round} WHERE l_id != '%d' AND vote_round = '%d'";
	$result = db_query($sql, $l_id, $vote_round);
	while($row = db_fetch_array($result)){
		$other_l_id = $row['l_id'];
		$other_round = $row['league_round'];
	}

	$sql = "SELECT * FROM {fanta_formazioni_insert} " .
			"WHERE l_id = '%d' " .
			"AND round = '%d' " .
			"AND t_id = '%d'";
	$result = db_query($sql, $other_l_id, $other_round, $t_id);
	if(db_affected_rows($result) > 0){
		$new_args['other_l_id'] = $other_l_id;
		$new_args['other_round'] = $other_round;
	}
	else {
		$new_args['other_l_id'] = $l_id;
		$new_args['other_round'] = $round - 1;
	}

	if(arg(0) == "formazione" && arg(1) == "admin")$new_args['is_admin'] = 1;


	return $new_args;
}

function get_groups_teams($l_id = 1){

	$result = db_query("SELECT * FROM {league_groups} WHERE l_id = '%d' AND active = 1 AND visible = 1 ORDER BY weight", $l_id);
	while($row = db_fetch_object($result)){
		$resulta = db_query("SELECT * FROM {league_leaguesteams} WHERE g_id = '%d' AND active = 1", $row->g_id);
		while($rowa = db_fetch_object($resulta)){
			$groups[$row->g_id][$rowa->t_id] = $rowa->t_id;
		}
	}

	return $groups;
}

function get_opponent($t_id, $l_id, $round){
	$sql = "SELECT * FROM {league_matches} " .
			"WHERE l_id = '%d' " .
			"AND round = '%d' " .
			"AND (t1_id = '%d' OR t2_id = '%d')";
	$result = db_query($sql, $l_id, $round, $t_id, $t_id );
	while($row = db_fetch_object($result)){
		if($t_id == $row->t1_id) return $row->t2_id;
		elseif($t_id == $row->t2_id) return $row->t1_id;
	}

}

function check_formazione_insert($t_id, $l_id, $round){
	$sql = "SELECT i_id FROM {fanta_formazioni_insert} " .
			"WHERE t_id = '%d' " .
			"AND l_id = '%d' " .
			"AND round = '%d'";
	$result = db_query($sql, $t_id, $l_id, $round );
	if(db_result($result)) return "<img src='".base_path()."sites/default/files/images/ok.png' title='Formazione già inserita'>";
	else return "<img src='".base_path()."sites/default/files/images/no.png' title='Formazione non inserita'>";
}

function make_league_tabs($function, $args = array() ){

	drupal_add_js('sites/all/plugins/jquery.tabs/jquery.tabs.js');
	drupal_add_css('sites/all/plugins/jquery.tabs/jquery.tabs.css', 'themes', 'all', FALSE);
	drupal_add_css('sites/all/modules/league/league.css', 'themes', 'all', FALSE);

	$tab_selected = (is_league($args["l_name"])) ? get_league_id($args["l_name"]) : 1 ;
	$args["selected_league"] = $args["l_name"];

	$js = "$(function(){
			$('#groups').tabs($tab_selected, {fxFade:true});
			//$('#groups').tabs(2);
			});
			";
	drupal_add_js($js, 'inline');

	$out = "";

	$leagues = get_leagues();

	if($leagues){

		$out .= "\n<div id='groups'>" .
				"\n<ul>";
		foreach($leagues as $l_id => $league){
			$out .= "\n<li><a href='#g_".$l_id."'><span>".$league->name."</span></a></li>";
		}
		$out .= "\n</ul>";

		foreach($leagues as $l_id => $league){

			$league_args = array(
							"l_name" => $league->name,
							"round" => (is_numeric($args["round"]) && $args["l_name"] == $league->name) ? $args["round"] : get_last_round_formazione($league->l_id),
							"t_id" => $args["t_id"],
							"selected_league" => $args["selected_league"]);

			$out .= "\n<div id='g_".$league->l_id."'>"
					.$function($league_args)
					."<div style='clear:both;'></div>"
					."\n</div>";
		}

		$out .= "\n</div>";

	}

	return $out;

}

function get_round_label($match){

	return (empty($match->round_label)) ? $match->round."&ordf; Giornata" : $match->round_label;
}
