<?php

function get_matches($g_id = ''){

	if(!empty($g_id)) $sql = "SELECT * FROM {league_matches} WHERE g_id = '%d'";
	else $sql = "SELECT * FROM {league_matches} ";

	$result = db_query($sql, $g_id);
	$matches = array();
	while($row = db_fetch_object($result)){
		$m_id = $row->m_id;
		$matches[$m_id] = $row;
	}
	return $matches;
}

#classifica
function get_num_played($t_id, $g_id){
	$sql = "SELECT count(*) as n FROM {league_matches} " .
			"WHERE (t1_id = '%d' OR t2_id = '%d') " .
			"AND g_id = '%d' " .
			"AND played = 1";
	$result = db_query($sql, $t_id, $t_id, $g_id) or die($sql.mysql_error());
	return db_result($result);
}

function get_num_win($t_id, $g_id){
	$sql = "SELECT count(*) as n FROM {league_matches} " .
			"WHERE winner_id = '%d' " .
			"AND g_id = '%d' " .
			"AND played = 1";
	$result = db_query($sql, $t_id, $g_id) or die($sql.mysql_error());
	return db_result($result);
}

function get_num_lost($t_id, $g_id){
	$sql = "SELECT count(*) as n FROM {league_matches} " .
			"WHERE (t1_id = '%d' OR t2_id = '%d') " .
			"AND winner_id != '%d' " .
			"AND winner_id != '-1' " .
			"AND g_id = '%d' " .
			"AND played = 1";
	$result = db_query($sql, $t_id, $t_id, $t_id, $g_id) or die($sql.mysql_error());
	return db_result($result);
}

function get_num_draw($t_id, $g_id){
	$sql = "SELECT count(*) as n FROM {league_matches} " .
			"WHERE (t1_id = '%d' OR t2_id = '%d')" .
			"AND winner_id = '-1' " .
			"AND g_id = '%d' " .
			"AND played = 1";
	$result = db_query($sql, $t_id, $t_id, $g_id) or die($sql.mysql_error());
	return db_result($result);
}

function get_goals_in($t_id, $g_id){
	$sql = "SELECT sum(gol_1) as n FROM {league_matches} " .
			"WHERE t1_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id' ";
	$result = db_query($sql);
	$gol_1 = db_result($result);

	$sql = "SELECT sum(gol_2) as n FROM {league_matches} " .
			"WHERE t2_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id'" ;
	$result = db_query($sql);
	$gol_2 = db_result($result);
	return $gol_1 + $gol_2;
}

function get_goals_out($t_id, $g_id){
	$sql = "SELECT sum(gol_1) as n FROM {league_matches} " .
			"WHERE t2_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id' ";
	$result = db_query($sql);
	$gol_1 = db_result($result);

	$sql = "SELECT sum(gol_2) as n FROM {league_matches} " .
			"WHERE t1_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id'" ;
	$result = db_query($sql);
	$gol_2 = db_result($result);
	return $gol_1 + $gol_2;
}

function get_points_in($t_id, $g_id){
	$sql = "SELECT sum(tot_1) as n FROM {league_matches} " .
			"WHERE t1_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id' ";
	$result = db_query($sql);
	$pt_1 = db_result($result);

	$sql = "SELECT sum(tot_2) as n FROM {league_matches} " .
			"WHERE t2_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id'" ;
	$result = db_query($sql);
	$pt_2 = db_result($result);
	return $pt_1 + $pt_2;

}

function get_points_out($t_id, $g_id){

	$sql = "SELECT sum(tot_1) as n FROM {league_matches} " .
			"WHERE t2_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id' ";
	$result = db_query($sql);
	$pt_1 = db_result($result);

	$sql = "SELECT sum(tot_2) as n FROM {league_matches} " .
			"WHERE t1_id = '$t_id' " .
			"AND played = 1 " .
			"AND g_id = '$g_id'" ;
	$result = db_query($sql);
	$pt_2 = db_result($result);
	return $pt_1 + $pt_2;

}

function get_standing_table($g_id){

	drupal_add_js('sites/all/plugins/tablesorter.js');
	drupal_add_css('sites/all/plugins/themes/blue/style.css', 'themes', 'all', FALSE);

	$teams = get_teams_group($g_id);

	$l_id = get_league_group($g_id);

	foreach($teams as $squadra_id => $squadra){

		$teams[$squadra_id]['n_played'] = 0 + get_num_played($squadra_id, $g_id);
		$teams[$squadra_id]['n_win'] = 0 + get_num_win($squadra_id, $g_id);
		$teams[$squadra_id]['n_lost'] = 0 + get_num_lost($squadra_id, $g_id);
		$teams[$squadra_id]['n_draw'] = 0 + get_num_draw($squadra_id, $g_id);
		$teams[$squadra_id]['goals_in'] = 0 + get_goals_in($squadra_id, $g_id);
		$teams[$squadra_id]['goals_out'] = 0 + get_goals_out($squadra_id, $g_id);
		$teams[$squadra_id]['points_in'] = 0 + get_points_in($squadra_id, $g_id);
		$teams[$squadra_id]['points_out'] = 0 + get_points_out($squadra_id, $g_id);
		$teams[$squadra_id]['pts'] = $teams[$squadra_id]['n_win'] * 3 + $teams[$squadra_id]['n_draw'] * 1;
		$pts[$squadra_id] = $teams[$squadra_id]['n_win'] * 3 + $teams[$squadra_id]['n_draw'] * 1;
		$gol_f[$squadra_id] = $teams[$squadra_id]['goals_in'];
		$pts_f[$squadra_id] = $teams[$squadra_id]['points_in'];
	}

	array_multisort($pts, SORT_DESC, $gol_f, SORT_DESC, $pts_f, SORT_DESC, $teams);

	$js = "$(function() {
	$('#classifica_".$g_id."').tablesorter({sortList: [[2,1],[7,1],[10,1]], widgets: ['zebra'], headers: { 0:{sorter: false}, 1:{sorter: false}}});
});	";

	drupal_add_js($js, 'inline');

	$out .= "\n<table id='classifica_".$g_id."' name='classifica_".$g_id."' class='tablesorter classifica'>" .
			"\n<thead>".
			"\n<tr>" .
				"\n<th></th>" .
				"\n<th>Squadra</th>" .
				"\n<th>Pts&nbsp;&nbsp;&nbsp;</th>" .
				"\n<th class='padding'>Giocate&nbsp;&nbsp;&nbsp; </th>" .
				"\n<th class='padding'>Vinte&nbsp;&nbsp;&nbsp; </th>" .
				"\n<th class='padding'>Perse&nbsp;&nbsp;&nbsp; </th>" .
				"\n<th class='padding'>Pari&nbsp;&nbsp;&nbsp; </th>" .
				"\n<th>Gol f.&nbsp;&nbsp;&nbsp;</th>" .
				"\n<th>Gol s.&nbsp;&nbsp;&nbsp;</th>" .
				"\n<th>Diff Gol&nbsp;&nbsp;&nbsp;</th>" .
				"\n<th>Pti f.&nbsp;&nbsp;&nbsp;</th>" .
				"\n<th>Pti s.&nbsp;&nbsp;&nbsp;</th>" .
				"\n<th>Diff Pti&nbsp;&nbsp;&nbsp;</th>" .
			"\n</tr>".
			"\n</thead>";

	$out .= "\n<tbody>";

	$i = 0;

	foreach($teams as $squadra_id => $squadra){

		$i++;

		$out .= "\n<tr>";
		$out .= "\n<td>".$i."</td>";
		$out .= "\n<td>".$squadra['name']."</td>";
		$out .= "\n<td>".$squadra['pts']."</td>";
		$out .= "\n<td>".$squadra['n_played']."</td>";
		$out .= "\n<td>".$squadra['n_win']."</td>";
		$out .= "\n<td>".$squadra['n_lost']."</td>";
		$out .= "\n<td>".$squadra['n_draw']."</td>";
		$out .= "\n<td>".$squadra['goals_in']."</td>";
		$out .= "\n<td>".$squadra['goals_out']."</td>";
		$out .= "\n<td>".($squadra['goals_in'] - $squadra['goals_out'])."</td>";
		$out .= "\n<td>".$squadra['points_in']."</td>";
		$out .= "\n<td>".$squadra['points_out']."</td>";
		$out .= "\n<td>".($squadra['points_in'] - $squadra['points_out'])."</td>";
		$out .= "\n</tr>";

	}

	$out .= "\n</tbody>";

	$out .= "</table>";

	return $out;
}

function get_teams(){
	$sql = "SELECT * FROM {league_teams} WHERE active = 1";
	$result = db_query($sql) or die($sql.mysql_error());
	while($row = db_fetch_array($result)){
		$t_id = $row['t_id'];
		$teams[$t_id] = $row;
	}
	return $teams;
}

function get_teams_names(){
	$teams = get_teams();
	foreach($teams as $team){
		$t[$team['t_id']] = $team['name'];
	}
	return $t;
}

function get_teams_group($g_id){
	$sql = "SELECT * FROM {league_leaguesteams} l, {league_teams} t " .
			"WHERE t.active = 1 " .
			"AND l.active = 1 ".
			"AND l.t_id = t.t_id " .
			"AND l.g_id = '%d'";
	$result = db_query($sql, $g_id) or die($sql.mysql_error());
	while($row = db_fetch_array($result)){
		$t_id = $row['t_id'];
		$teams[$t_id]['name'] = $row['name'];
	}
	return $teams;
}

function get_groups($l_id = '', $args = array()){

	$league_name = get_league_name($l_id);
	if(!is_league($league_name)) $sql = "SELECT * FROM {league_groups} WHERE active = 1";
	else $sql = "SELECT * FROM {league_groups} WHERE active = 1 AND l_id = '%d'";

	if(count($args) > 0){
		foreach($args as $key => $value){
			$sql .= " AND ".$key." ='".$value."'";
		}
	}

	$sql .= " ORDER BY weight ASC";

	$result = db_query($sql, $l_id) or die($sql.mysql_error());
	while($row = db_fetch_array($result)){
		$g_id = $row['g_id'];
		$groups[$g_id]['name'] = $row['name'];
	}
	return $groups;
}

function make_tabs($function, $l_name, $args = array()){

	drupal_add_js('sites/all/plugins/jquery.tabs/jquery.tabs.js');
	drupal_add_css('sites/all/plugins/jquery.tabs/jquery.tabs.css', 'themes', 'all', FALSE);
	drupal_add_css('sites/all/modules/league/league.css', 'themes', 'all', FALSE);
	$js = "$(function(){
			$('#groups').tabs({fxFade:true});
			});
			";
	drupal_add_js($js, 'inline');

	$l_id = get_league_id($l_name);

	$out = "";

	$groups = get_groups($l_id, $args);

	if($groups){

		$out .= "\n<div id='groups'>" .
				"\n<ul>";
		foreach($groups as $g_id => $group){
			$out .= "\n<li><a href='#g_".$g_id."'><span>".$group['name']."</span></a></li>";
		}
		$out .= "\n</ul>";

		foreach($groups as $g_id => $group){
			$out .= "\n<div id='g_".$g_id."'>"
					.$function($g_id)
					."\n</div>";
		}

		$out .= "\n</div>";

	}

	return $out;
}

function get_matches_table($g_id){

	$out = "<span><a id='".$g_id."_top'></a></span>";

	//ultima e prossima giornata
	if($round = get_last_round($g_id)){
		$matches = get_round_matches($round, $g_id);
		$out .= "\n<div class='round'>" .
				"\n<h4>Ultima giornata</h4>";
		$out .= show_matches($matches);
		$out .= "\n</div>";
	}

	if($round = get_next_round($g_id)){
		$matches = get_round_matches($round, $g_id);
		$out .= "\n<div class='round'>".
				"\n<h4>Prossima giornata</h4>";
		$out .= show_matches($matches);
		$out .= "\n</div>";
	}

	$out .= "\n<div style='clear:both;height:20px;'></div>";

	//elenco giornate
	$out .= "<div style='clear:both;'></div>".get_round_list($g_id);

	//calendario completo
	$matches = get_matches($g_id);
	$out .= show_matches($matches, $g_id);

	return $out;
}

function transform_data($d){
	$datetime = explode(' ', $d);
	$date = explode('-', $datetime[0]);
	return $date[2].'-'.$date[1].'-'.$date[0].'&nbsp;&nbsp;&nbsp;';//.$datetime[1];
}

function show_match_details($m_id){

	$teams = get_teams();
	$matches = get_matches();
	$match = $matches[$m_id];

	$out = "<div style='margin:auto; margin-bottom: 10px; text-align: center;'>";

	$out .= "<h3>".$match->round."&ordf; Giornata</h3><br>";
	$out .= "<h4>".$teams[$match->t1_id]['name']." - ".$teams[$match->t2_id]['name']."</h4><hr>";
	$out .= "</div>";

	$out .= show_team_details($match->t1_id, $match->round, $match->l_id);
	$out .= "<hr>";

	$out .= show_team_details($match->t2_id, $match->round, $match->l_id);

	return $out;

}

function get_round_list($g_id = ''){

	if(!empty($g_id)){
		$sql = "SELECT * FROM {league_matches} WHERE g_id = '%d' ";
		$result = db_query($sql, $g_id);
	}
	else {
		$sql = "SELECT * FROM {league_matches}";
		$result = db_query($sql);
	}

	while($row = db_fetch_array($result)){
		$r_id = $row['round'];
		$rounds[$r_id] = empty($row["round_label"]) ? $row["round"] : $row["round_label"];
	}

	$out = "";

	$out .= "<div class='round_list' id='round-list'>";

	$out .= "\n<ul>";
	foreach($rounds as $round => $round_label){
		$out .= "\n<li class='round_list'>" .
					"<a href='#".$g_id."_".$round."'>$round_label</a>" .
				"</li>";
	}
	$out .= "\n<ul>";
	$out .= "\n</div>" .
			"\n<div style='clear:both;'></div>";

	return $out;
}

function get_last_round($g_id){

	$sql = "SELECT max(round) FROM {league_matches} WHERE g_id = $g_id AND played = 1";
	$result = db_query($sql);
	return db_result($result);
}

function get_next_round($g_id){
	$sql = "SELECT min(round) FROM {league_matches} WHERE g_id = '%d' AND played = 0";
	$result = db_query($sql, $g_id);
	return db_result($result);
}

function get_round_matches($r_id, $g_id = '', $l_id = ''){

	if($g_id == '')
		$sql = "SELECT * FROM {league_matches} WHERE l_id = '%d' AND round = '%d'";
	elseif($l_id == '')
		$sql = "SELECT * FROM {league_matches} WHERE g_id = '%d' AND round = '%d'";

	$args[0] = ($g_id == '') ? $l_id : $g_id;
	$args[1] = $r_id;

	$result = db_query($sql, $args) or die($sql.mysql_error());
	$matches = array();
	while($row = db_fetch_object($result)){
		$m_id = $row->m_id;
		$matches[$m_id] = $row;
	}
	return $matches;
}

function show_matches($matches, $g_id = ''){

	$out = "";

	$teams = get_teams();

	foreach($matches as $m_id => $match){
		$round = $match->round;
		$m_id = $match->m_id;
		$round_match[$round][$m_id] = $match;
	}

	ksort($round_match);

	$i = 0;

	foreach($round_match as $r_id => $round){

		$header = array(); $rows = array();

		$i++;

		$attributes = array("id" => "round_".$r_id);

		foreach($round as $m_id => $match) $date = $match->date;

		#table header
		$round_name = (empty($match->round_label)) ? $r_id."&deg; Giornata" : $match->round_label;
		$header[] = array("data" => "<span>".$round_name."</span><span style='margin-left:4px; font-size: 80%;'>".transform_data($date)."</span>".$round_label, "colspan" => 3);

		if($match->played != 0) {
			#$header[] = array("data" => "Risultato", "colspan" => 2);
			#$header[] = array("data" => "Punteggi", "colspan" => 2);
		}

		if(count($round_match) > 1)$header[] = array("data" => "<a href='#".$g_id."_top' title='Torna su'>" .
					"<img src='".base_path().path_to_theme()."/images/top.png'>" .
				"</a>", "colspan" => 2);

		#table body
		foreach($round as $m_id => $match){

			if(!empty($match->match_label))	$rows[$m_id][] = array("data" => "(".$match->match_label.")", "class" => "team");

			$t1_name = ($match->t1_id != 0) ? $teams[$match->t1_id]['name'] : $match->t1_label;
			$t2_name = ($match->t2_id != 0) ? $teams[$match->t2_id]['name'] : $match->t2_label;

			#$rows[$m_id][] = array("data" => $teams[$match->t1_id]['name']." - ".$teams[$match->t2_id]['name'], "class" => "team");
			$rows[$m_id][] = array("data" => $t1_name." - ".$t2_name, "class" => "team");

			if($match->played == 1){
				$rows[$m_id][] = array("data" => $match->gol_1." - ".$match->gol_2, "class" => "gol");
				$rows[$m_id][] = array("data" => $match->tot_1." - ".$match->tot_2, "class" => "pt");
				$rows[$m_id][] = "<a rel='lightframe[".$match->round."_".$match->g_id."|width:770px;]' href='".base_path()."scheda_partita/".$m_id."' title='Dettagli partita'>" .
								"<img src='".base_path().path_to_theme()."/images/dettagli.png'></a>";

			}
		}

		$out .= "<div class='round' id='".$g_id."_".$r_id."'>".theme_table($header, $rows, $attributes)."</div>";

		if($i%2 == 0)$out .= "<div style='clear:both;'></div>";
	}

	if($i != 1)
		$out .= "<div style='clear:both;'></div>";

	return $out;
}

function get_leagues(){

	$leagues = array();
	$sql = "SELECT * FROM {league_leagues} WHERE active = 1";
	$result = db_query($sql);
	while($row = db_fetch_object($result)){
		$l_id = $row->l_id;
		$leagues[$l_id] = $row;
	}

	return $leagues;

}

function get_league_played($l_id){
	$sql = "SELECT count(*) as n FROM {league_matches} " .
			"WHERE played = 1";
	$result = db_query($sql) or die($sql.mysql_error());
	return db_result($result) / (count(get_teams($l_id)) * 2) ;
}

function is_league($l_name){

	$sql = "SELECT l_id FROM {league_leagues} WHERE name = '%s'";
	$result = db_query($sql, $l_name);
	return db_result($result);
}

function league_classifica($l_name = ''){

	if(empty($l_name) || !is_league($l_name)) $out = choose_league();

	else $out = make_tabs('get_standing_table', $l_name, array("standing" => 1));

	return $out;

}

function league_calendario($l_name = ''){

	if(empty($l_name) || !is_league($l_name)) $out = choose_league();

	else $out = make_tabs('get_matches_table', $l_name);

	return $out;

}

function choose_league($tail = '', $get_round = 'no', $message = ''){

	$out = "";

	$leagues = get_leagues();

	if(!empty($tail)){
		$function_tail = 'get_tail_'.$tail;
	}

	if($message) $out .= "<p>".$message."</p>";

	if($leagues){
		$out .= "\n<ul>";
		foreach($leagues as $l_id => $league){

			if(!empty($tail)) $url_tail = '/'.$function_tail($l_id);

			$show_round = "";
			if($get_round == 'yes'){
				$round = get_next_league_round($l_id);
				$show_round = " (".$round."&ordf; Giornata)";
			}

			$out .= "\n<li><a href='".base_path().arg(0)."/".$league->name.$url_tail."'>".$league->name.$show_round."</a></li>";
		}
		$out .= "\n</ul>";
	}

	return $out;
}

function get_league_group($g_id){

	$sql = "SELECT l_id FROM {league_groups} WHERE g_id = '%d'";
	$result = db_query($sql, $g_id);
	return db_result($result);
}

function get_league_id($l_name){

	$sql = "SELECT l_id FROM {league_leagues} " .
			"WHERE name = '%s' ";
	$result = db_query($sql, $l_name);
	return db_result($result);
}

function get_league_name($l_id){

	$sql = "SELECT name FROM {league_leagues} " .
			"WHERE l_id = '%d' ";
	$result = db_query($sql, $l_id);
	return db_result($result);
}

function show_team_details($t_id, $league_round, $l_id){

	$teams = get_teams();

	$out = "<div style='margin:auto; margin-top: 10px; text-align: center;'>";
	$out .= "<h3>".$teams[$t_id]['name']."</h3>";
	$out .= "<p><img src='".base_path().$teams[$t_id]['shirt']."'></p>";

	$sql = "SELECT vote_round FROM {fanta_votes_round} " .
			"WHERE league_round = '%d' " .
			"AND l_id = '%d'";
	$result = db_query($sql, $league_round, $l_id);
	$round = db_result($result);

	$votes = get_votes($round);

	$players = get_players();

	$titolari = get_formazione_titolari($t_id, $l_id, $league_round, $players);
	$riserve = get_formazione_riserve($t_id, $l_id, $league_round, $players);

	$modulo = array();
	foreach($titolari as $titolare){
		$modulo[$players[$titolare['pl_id']]->role]++;
	}
	unset($modulo[0]);

	$out .= "<p>".implode("-",$modulo)."</p>";
	$out .= "</div>";

	$points = 0;

	$header = array("", "Ruolo", "Nome", "Squadra", "", "Totale", "Voto", "Gol Fatti", "Gol Subiti", "Assist", "Rig Sbagliato", "Rig Parato", "Autogol");

	$rows = array();

	foreach($titolari as $titolare){
		$pl_id = $titolare['pl_id'];

		$rows[$pl_id][] = ($titolare['gioca'] == 1) ? "" : "<img src='".base_path()."sites/default/files/images/out.png'>";

		$rows[$pl_id][] = convert_ruolo($players[$titolare['pl_id']]->role);
		$rows[$pl_id][] = $players[$titolare['pl_id']]->name;
		$rows[$pl_id][] = ucwords(convert_teams($players[$titolare['pl_id']]->team));
		if($titolare['gioca'] == 1){
			$rows[$pl_id][] = get_amm_esp($votes[$pl_id]->amm, $votes[$pl_id]->esp);
			$rows[$pl_id][] = $votes[$pl_id]->tot;
			$rows[$pl_id][] = $votes[$pl_id]->vote;
			$rows[$pl_id][] = $votes[$pl_id]->gol_fatto + $votes[$pl_id]->rig_fatto;
			$rows[$pl_id][] = $votes[$pl_id]->gol_subito;
			$rows[$pl_id][] = $votes[$pl_id]->assist;
			$rows[$pl_id][] = $votes[$pl_id]->rig_sbagliato;
			$rows[$pl_id][] = $votes[$pl_id]->rig_parato;
			$rows[$pl_id][] = $votes[$pl_id]->autogol;

			$points += $votes[$pl_id]->tot;
		}
		else $rows[$pl_id][] = array("data" => "", "colspan" => 10);

	}

	$rows['space'][] = array("data" => "", "colspan" => 13);

	foreach($riserve as $riserva){
		if($riserva['gioca'] == 1){
			$pl_id = $riserva['pl_id'];
			$rows[$pl_id][] = "<img src='".base_path()."sites/default/files/images/in.png'>";
			$rows[$pl_id][] = convert_ruolo($players[$riserva['pl_id']]->role);
			$rows[$pl_id][] = $players[$riserva['pl_id']]->name;
			$rows[$pl_id][] = ucwords(convert_teams($players[$riserva['pl_id']]->team));
			if($riserva['gioca'] == 1){
				$rows[$pl_id][] = get_amm_esp($votes[$pl_id]->amm, $votes[$pl_id]->esp);
				$rows[$pl_id][] = $votes[$pl_id]->tot;
				$rows[$pl_id][] = $votes[$pl_id]->vote;
				$rows[$pl_id][] = $votes[$pl_id]->gol_fatto + $votes[$pl_id]->rig_fatto;
				$rows[$pl_id][] = $votes[$pl_id]->gol_subito;
				$rows[$pl_id][] = $votes[$pl_id]->assist;
				$rows[$pl_id][] = $votes[$pl_id]->rig_sbagliato;
				$rows[$pl_id][] = $votes[$pl_id]->rig_parato;
				$rows[$pl_id][] = $votes[$pl_id]->autogol;

				$points += $votes[$pl_id]->tot;
			}
			else $rows[$pl_id][] = array("data" => "", "colspan" => 10);
		}
	}

	#foreach($riserve as $riserva)$rows[] = array($players[$riserva['pl_id']]->name);

	$out .= theme_table($header, $rows);

	$mod = get_detail_modificatori($t_id, $l_id, $league_round);

	$bonus = get_bonus($t_id, $l_id, $league_round);

	$totale = $points + $mod['dif'] + $mod['centr'] + $bonus;
	$gol = floor(($totale - 60)/ 6);
	$gol = ($gol >= 0) ? $gol : 0 ;

	$rows = array();
	$rows[] = array("Punti", $points);
	$rows[] = array("Mod Difesa", $mod['dif']);
	$rows[] = array("Mod Centrocampo", $mod['centr']);

	if($bonus) $rows[] = array("Bonus", $bonus);


	$rows[] = array("Totale", $totale);
	$rows[] = array("Gol", $gol);

	$out .= "<div style='width: 20%; margin:auto; margin-top: 10px; text-align: left;'>".theme_table(array(), $rows, array("width" => "100%", "style" => "text-align: left;"))."</div>";

	return $out;
}

function get_formazione_titolari($t_id, $l_id, $round, $players){

	$formazione = array(); $names = array(); $positions = array(); $roles = array();
	$sql = "SELECT * FROM {fanta_formazioni} " .
			"WHERE t_id = '%d' " .
			"AND l_id = '%d' " .
			"AND round = '%d' " .
			"AND posizione = 1";
	$result = db_query($sql, $t_id, $l_id, $round);
	while($row = db_fetch_array($result)){
		$formazione[] = $row;
		$names[] = $players[$row['pl_id']]->name;
		$roles[] = $players[$row['pl_id']]->role;
		$positions[] = $row['posizione'];
	}

	array_multisort($positions, SORT_ASC, $roles, SORT_ASC, $names, SORT_ASC, $formazione);

	return $formazione;

}

function get_formazione_riserve($t_id, $l_id, $round, $players){

	$formazione = array(); $names = array(); $positions = array(); $roles = array();
	$sql = "SELECT * FROM {fanta_formazioni} " .
			"WHERE t_id = '%d' " .
			"AND l_id = '%d' " .
			"AND round = '%d' " .
			"AND posizione > 1";
	$result = db_query($sql, $t_id, $l_id, $round);
	while($row = db_fetch_array($result)){
		$formazione[] = $row;
		$names[] = $players[$row['pl_id']]->name;
		$roles[] = $players[$row['pl_id']]->role;
		$positions[] = $row['posizione'];
	}

	array_multisort($roles, SORT_ASC, $positions, SORT_ASC, $names, SORT_ASC, $formazione);

	return $formazione;

}

function get_amm_esp($amm, $esp){

	if($amm == 1) return "<img src='".base_path()."sites/default/files/images/amm.png'>";
	elseif($esp == 1) return "<img src='".base_path()."sites/default/files/images/esp.png'>";
	else return "";
}

function get_detail_modificatori($t_id, $l_id, $round){

	$sql = "SELECT * FROM {league_matches} " .
		"WHERE l_id = '%d' " .
		"AND round = '%d' " .
		"AND (t1_id = '%d' OR t2_id = '%d')";
	$result = db_query($sql, $l_id, $round, $t_id, $t_id);
	while($row = db_fetch_array($result)){
		if($t_id == $row['t1_id']){
			$mod['dif'] = $row['mod_dif_2'];
			$mod['centr'] = $row['mod_centr_1'];
		}
		if($t_id == $row['t2_id']){
			$mod['dif'] = $row['mod_dif_1'];
			$mod['centr'] = $row['mod_centr_2'];
		}
	}

	return $mod;
}

function get_bonus($t_id, $l_id, $league_round){

	$sql = "SELECT * FROM {league_matches} " .
			"WHERE l_id = '%d' " .
			"AND round = '%d' " .
			"AND (t1_id = '%d' OR t2_id = '%d')";
	$result = db_query($sql, $l_id, $league_round, $t_id, $t_id);
	while($row = db_fetch_array($result)){
		if($row['t1_id'] == $t_id) $bonus = $row['bonus_t1'];
		if($row['t2_id'] == $t_id) $bonus = $row['bonus_t2'];
	}

	return ($bonus > 0) ? $bonus : "";

}

function get_rounds_played($l_id = 1){
	
	$sql = "SELECT DISTINCT round FROM {league_matches} 
				WHERE l_id = '%d' 
				AND played = 1";
	$result = db_query($sql, $l_id);
	while($row = db_fetch_array($result)){
		$rounds[$row["round"]] = $row["round"]; 
	}
	
	return $rounds;	
}